// Author: 5294

#include "VigenereCipher.h"

ifstream openInFile(const string& name) {
	ifstream stream;
	stream.open(name.c_str());
	if (stream.fail()) {
		perror("Issues opening file");
		exit(1);
	}
	return stream;
}

string strip(const string& str) {
	stringstream stream;
	for (const char& s : str) {
		if ('A' <= s && s <= 'Z') {
			stream << s;
		} else if ('a' <= s && s <= 'z' ) {
			stream<< (char)toupper(s);
		}
		if (' ' == s) {
			stream << " ";
		}
	}
	return stream.str();
}

string encrypt(const string& keyword, const string& plainText, const Vtable& t) {
	stringstream stream;
	size_t idx = 0;
	for (const char& pt: plainText) {
		if ('A' <= pt && pt <= 'Z' ) {
			stream << t[keyword[idx++] - 'A'][pt - 'A'];
			idx %= keyword.size();
		}
		if (' ' == pt) {
			stream << " ";
		}
	}

	return stream.str();
}
int find(const Row& r, char c) {
	for (int x = 0; x < r.size(); x++ ) {
		if (r[x] == c) {
			return x;
		}
	}
	return 0;
}
string decrypt(const string& keyword, const string& cipherText, const Vtable& t) {
	stringstream stream;
	size_t idx = 0;
	for (const char& c : cipherText) {
		if (c != ' ') {
			stream << (char)( find(t[keyword[idx] - 'A'], c) + 'A');
			idx++;
			idx %= keyword.size();
		}
		if (' ' == c) {
			stream << " ";
		}
	}
	return stream.str();
}
Vtable getVTable() {
	Row row;
	Vtable vtable;
	for (char x = 'A'; x <= 'Z'; x++) {
		row.push_back(x);
	}

	for (int x = 0; x < ALPHABET_SIZE; x++) {
		vtable.push_back(row);
		shr(row);
	}
	vtable.shrink_to_fit();
	return vtable;
}
